=== debian/changelog ===
lepton (0.01-0mx150+1) mx; urgency=low

  * Initial packaging for MX-15

 -- Timothy E. Harris <maintainer@mepiscommunity.org>  Sat, 16 Jul 2016 18:19:12 -0400
