=== debian/control ===
Source: lepton
Section: utils
Priority: optional
Maintainer: Timothy E. Harris <maintainer@mepiscommunity.org>
Standards-Version: 3.9.4
Build-Depends: debhelper (>= 9~),
               dh-autoreconf
Homepage: https://github.com/dropbox/lepton

Package: lepton
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Lepton is a tool and file format for losslessly compressing JPEGs by an average of 22%.
 This can be used to archive large photo collections, or to serve images live and save 22% bandwidth.
