## lepton 1.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -211,5 +211,3 @@
 )
 
 ADD_DEPENDENCIES(lepton version)
-
-install (TARGETS lepton lepton-avx DESTINATION bin)
