=== debian/changelog ===
lepton (1.0-1) unstable; urgency=low

  * Initial release. Closes: #831365

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Sat, 16 Jul 2016 02:51:31 +0800
