=== debian/control ===
Source: lepton
Section: graphics
Priority: optional
Maintainer: Debian PhotoTools Maintainers <pkg-phototools-devel@lists.alioth.debian.org>
Uploaders: ChangZhuo Chen (陳昌倬) <czchen@debian.org>
Build-Depends: debhelper (>=9),
               dh-autoreconf,
               libssl-dev,
               pkg-config,
               python,
               zlib1g-dev,
Standards-Version: 3.9.8
Homepage: https://github.com/dropbox/lepton
Vcs-Git: https://anonscm.debian.org/git/pkg-phototools/lepton.git
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-phototools/lepton.git

Package: lepton
Architecture: any
Multi-Arch: foreign
Depends: ${misc:Depends},
         ${shlibs:Depends},
Description: tool to compress JPEGs losslessly
 Lepton is a tool and file format for losslessly compressing JPEGs by an average
 of 22%.
 .
 This can be used to archive large photo collections, or to serve images live
 and save 22% bandwidth.
