## lepton 1.2.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -2,10 +2,38 @@
 project(lepton)
 
 FIND_PACKAGE(Git)
+option(USE_SYSTEM_DEPENDENCIES "Use system dependencies for libz and openssl" OFF)
+set(flags_configs "")
+if("${CMAKE_CONFIGURATION_TYPES}" STREQUAL "")
+    if("${CMAKE_BUILD_TYPE}" STREQUAL "")
+         list(APPEND flags_configs CMAKE_C_FLAGS)
+         list(APPEND flags_configs CMAKE_CXX_FLAGS)
+    else()
+            string(TOUPPER ${CMAKE_BUILD_TYPE} config)
+            list(APPEND flags_configs CMAKE_C_FLAGS_${config})
+            list(APPEND flags_configs CMAKE_CXX_FLAGS_${config})
+    endif()
+else()
+        # handle multi config generators (like msvc, xcode
+    foreach(config ${CMAKE_CONFIGURATION_TYPES})
+            string(TOUPPER ${config} config)
+            list(APPEND flags_configs CMAKE_C_FLAGS_${config})
+            list(APPEND flags_configs CMAKE_CXX_FLAGS_${config})
+    endforeach()
+endif()
+IF(WIN32)
+
+    foreach(flags ${flags_configs})
+        if(${flags} MATCHES "/MD")
+             string(REGEX REPLACE "/MD" "/MT" ${flags} "${${flags}}")
+        endif()
+    endforeach()
+ENDIF()
+
 
 SET(CMAKE_CXX_FLAGS "-std=c++11 -fno-exceptions -fno-rtti")
 SET(CMAKE_C_FLAGS "-std=c99 -DHAVE_CONFIG_H ")
-
+IF(NOT USE_SYSTEM_DEPENDENCIES)
 add_library(localmd5 dependencies/md5/md5.c)
 add_library(localzlib
 dependencies/zlib/inflate.c
@@ -34,7 +62,7 @@
 dependencies/zlib/gzread.c
 dependencies/zlib/deflate.h
 dependencies/zlib/gzlib.c)
-
+ENDIF()
 
 include_directories(
     ${CMAKE_BINARY_DIR}
@@ -125,15 +153,38 @@
    src/io/MemMgrAllocator.hh
    )
 add_executable(lepton ${LEPTON_SOURCES})
+add_executable(lepton-slow-best-ratio ${LEPTON_SOURCES})
 add_executable(lepton-avx ${LEPTON_SOURCES})
 SET(ADDITIONAL_FLAGS)
 IF(NOT APPLE)
 IF(NOT WIN32)
-    SET(ADDITIONAL_FLAGS -static-libstdc++ pthread -Wl,--no-export-dynamic -lstdc++)
+IF(USE_SYSTEM_DEPENDENCIES)
+    SET(ADDITIONAL_FLAGS -static-libstdc++ pthread -Wl,--no-export-dynamic)
+ELSE()
+    SET(ADDITIONAL_FLAGS -lstdc++ -static-libstdc++ pthread -Wl,--no-export-dynamic)
+ENDIF()
 ENDIF()
 ENDIF()
 SET(ADDITIONAL_COMPILE_FLAGS)
 SET(ADDITIONAL_DEFINES)
+
+IF(USE_SYSTEM_DEPENDENCIES)
+    SET(ADDITIONAL_DEFINES "${ADDITIONAL_DEFINES} -DUSE_SYSTEM_LIBRARIES -DUSE_SYSTEM_MD5_DEPENDENCY")
+ENDIF()
+
+
+
+option(BEST_RATIO_SLOW_DECOMPRESSION "Turn on single threaded decode in exchange for more compression ratio " OFF)
+
+IF(BEST_RATIO_SLOW_DECOMPRESSION)
+SET(ADDITIONAL_DEFINES "${ADDITIONAL_DEFINES} -DDEFAULT_SINGLE_THREAD")
+ENDIF()
+
+option(BASELINE_JPEG_ONLY "Only support small < 4MB baseline jpegs, instead of progressive and large JPEGS." OFF)
+IF(NOT BASELINE_JPEG_ONLY)
+SET(ADDITIONAL_DEFINES "${ADDITIONAL_DEFINES} -DDEFAULT_ALLOW_PROGRESSIVE -DHIGH_MEMORY")
+ENDIF()
+
 option(UNSAFE_SKIP_VALIDATION "Don't check roundtrip: can cause data corruption unless you have a following validation step" OFF)
 IF(UNSAFE_SKIP_VALIDATION)
 SET(ADDITIONAL_DEFINES "${ADDITIONAL_DEFINES} -DSKIP_VALIDATION")
@@ -145,15 +196,36 @@
 ELSE()
 IF(NOT APPLE)
 IF(NOT WIN32)
+IF(NOT USE_SYSTEM_DEPENDENCIES)
     SET(ADDITIONAL_FLAGS "-static ${ADDITIONAL_FLAGS}")
 ENDIF()
 ENDIF()
 ENDIF()
+ENDIF()
+IF(USE_SYSTEM_DEPENDENCIES)
+find_package(ZLIB)
+include_directories(${ZLIB_INCLUDE_DIRS})
+find_package(OpenSSL)
+include_directories(${OPENSSL_INCLUDE_DIRS})
+target_link_libraries(lepton ${OPENSSL_LIBRARIES} ${ZLIB_LIBRARIES} ${ADDITIONAL_FLAGS})
+target_link_libraries(lepton-slow-best-ratio ${OPENSSL_LIBRARIES} ${ZLIB_LIBRARIES} ${ADDITIONAL_FLAGS})
+target_link_libraries(lepton-avx ${OPENSSL_LIBRARIES} ${ZLIB_LIBRARIES} ${ADDITIONAL_FLAGS})
+ELSE()
 target_link_libraries(lepton localzlib localmd5 ${ADDITIONAL_FLAGS})
+target_link_libraries(lepton-slow-best-ratio localzlib localmd5 ${ADDITIONAL_FLAGS})
 target_link_libraries(lepton-avx localzlib localmd5 ${ADDITIONAL_FLAGS})
 set_target_properties(localmd5 PROPERTIES COMPILE_FLAGS "-msse4.2 ${ADDITIONAL_COMPILE_FLAGS} ${ADDITIONAL_DEFINES}")
-set_target_properties(localzlib PROPERTIES COMPILE_FLAGS "-msse4.2 -include unistd.h ${ADDITIONAL_COMPILE_FLAGS} ${ADDITIONAL_DEFINES}")
+
+IF(WIN32)
+SET(ZLIB_EXTRA_INCLUDE_DIRS)
+ELSE()
+SET(ZLIB_EXTRA_INCLUDE_DIRS " -include unistd.h")
+ENDIF()
+
+set_target_properties(localzlib PROPERTIES COMPILE_FLAGS "-msse4.2 ${ZLIB_EXTRA_INCLUDE_DIRS} ${ADDITIONAL_COMPILE_FLAGS} ${ADDITIONAL_DEFINES}")
+ENDIF()
 set_target_properties(lepton PROPERTIES COMPILE_FLAGS "-msse4.2 ${ADDITIONAL_COMPILE_FLAGS} ${ADDITIONAL_DEFINES}")
+set_target_properties(lepton-slow-best-ratio PROPERTIES COMPILE_FLAGS "-msse4.2 ${ADDITIONAL_COMPILE_FLAGS} ${ADDITIONAL_DEFINES} -DDEFAULT_SINGLE_THREAD")
 IF(WIN32)
 set_target_properties(lepton-avx PROPERTIES COMPILE_FLAGS "-march=core-avx2 /arch:AVX2 -D__AVX2__ -D__AVX__ ${ADDITIONAL_COMPILE_FLAGS} ${ADDITIONAL_DEFINES}")
 ELSE()
@@ -184,7 +256,11 @@
    src/vp8/util/memory.cc
    test_suite/test_invariants.cc
  )
+IF(USE_SYSTEM_DEPENDENCIES)
+target_link_libraries(test_invariants ${ZLIB_LIBRARIES} ${ADDITIONAL_FLAGS})
+ELSE()
 target_link_libraries(test_invariants localzlib ${ADDITIONAL_FLAGS})
+ENDIF()
 #set_target_properties(print-model PROPERTIES COMPILE_FLAGS "-msse4.2")
 set_target_properties(test_invariants PROPERTIES COMPILE_FLAGS "-msse4.2")
 
@@ -211,3 +287,5 @@
 )
 
 ADD_DEPENDENCIES(lepton version)
+
+install (TARGETS lepton lepton-slow-best-ratio lepton-avx DESTINATION bin)
