=== debian/changelog ===
lepton (1.2.1-1) unstable; urgency=medium

  * New upstream release. Closes: #831814
  * Kill lepton after unit test to ensure no process leaves after build.
    Closes: #831897
  * Set architecture to i386 amd64 x32 due to SSE.

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Sat, 23 Jul 2016 00:43:13 +0800

lepton (1.0-2) unstable; urgency=medium

  * Add manpage.

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Sun, 17 Jul 2016 20:35:00 +0800
