=== debian/control ===
--- 
+++ 
@@ -4,10 +4,14 @@
 Maintainer: Debian PhotoTools Maintainers <pkg-phototools-devel@lists.alioth.debian.org>
 Uploaders: ChangZhuo Chen (陳昌倬) <czchen@debian.org>
 Build-Depends: debhelper (>=9),
+               asciidoc,
                dh-autoreconf,
                libssl-dev,
                pkg-config,
+# FIXME: workaround for #831897, https://github.com/dropbox/lepton/issues/42
+               procps,
                python,
+               xmlto,
                zlib1g-dev,
 Standards-Version: 3.9.8
 Homepage: https://github.com/dropbox/lepton
@@ -15,7 +19,9 @@
 Vcs-Browser: https://anonscm.debian.org/cgit/pkg-phototools/lepton.git
 
 Package: lepton
-Architecture: any
+# lepton uses SSE vector instructions, so it only supports the following
+# architectures.
+Architecture: i386 amd64 x32
 Multi-Arch: foreign
 Depends: ${misc:Depends},
          ${shlibs:Depends},
