=== debian/rules ===
--- 
+++ 
@@ -6,6 +6,15 @@
 %:
 	dh $@ --with autoreconf
 
+override_dh_auto_configure:
+	cat debian/*manpages | sed 's/$$/.txt/p' | xargs -n 1 a2x --attribute=footer-style=none --doctype manpage --format manpage
+	dh_auto_configure -- --enable-system-dependencies
+
 override_dh_install:
 	dh_install
 	rm -f debian/lepton/usr/bin/test_invariants
+
+# FIXME: workaround for #831897, https://github.com/dropbox/lepton/issues/42
+override_dh_auto_test:
+	dh_auto_test
+	pkill lepton
