=== debian/changelog ===
lepton (1.2.1+20170405-3build1) bionic; urgency=high

  * No change rebuild against openssl1.1.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 05 Feb 2018 16:50:44 +0000

lepton (1.2.1+20170405-3) unstable; urgency=medium

  * Make armhf buildable by using macros properly.
    Thanks Edmund Grimley Evans.
  * Remove -march=native.
    Thanks Edmund Grimley Evans.
  * Use -msse4.1 in Intel platform to prevent FTBFS.
  * Use -Wl,--as-needed to prevent unnecessary dependency.

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Fri, 02 Jun 2017 23:34:43 +0800

lepton (1.2.1+20170405-2) unstable; urgency=medium

  * Add patches to support non-Intel architecture (Closes: #835108, #863446).
    Thanks Edmund Grimley Evans.

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Sat, 27 May 2017 22:46:57 +0800

lepton (1.2.1+20170405-1) unstable; urgency=medium

  * Use git snapshot 6d940eb00576f2b262e9c478c8dfed1559d32563 for
    CVE-2017-8891 (Closes: #862446).

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Sun, 14 May 2017 00:16:01 +0800

lepton (1.2.1-3) unstable; urgency=high

  * Merge upstream patch for CVE-2017-7448 (Closes: #859714).

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Thu, 06 Apr 2017 23:19:12 +0800

lepton (1.2.1-2) unstable; urgency=medium

  * Patch to fix unit test so that it will not left lepton process.
    Closes: #831897

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Sun, 31 Jul 2016 22:22:36 +0800
