=== debian/watch ===
# You must remove unused comment lines for the released package.
version=3
https://github.com/dropbox/lepton/releases .*/(\d\S*)\.tar.gz
